## ros-foxy-mvsim 0.7.0

=== CMakeLists.txt ===
#*+-------------------------------------------------------------------------+
# |                       MultiVehicle simulator (libmvsim)                 |
# |                                                                         |
# |  https://github.com/ual-arm-ros-pkg/multivehicle-simulator              |
# |                                                                         |
# | Copyright (C) 2014-2023  Jose Luis Blanco Claraco                       |
# | Distributed under 3-clause BSD License                                  |
# |   See COPYING                                                           |
# +-------------------------------------------------------------------------+

cmake_minimum_required(VERSION 3.9) # for CMAKE_MATCH_1

if("$ENV{ROS_VERSION}" STREQUAL "2")
	set(DETECTED_ROS2 TRUE)
	set(PACKAGE_ROS_VERSION 2)
elseif("$ENV{ROS_VERSION}" STREQUAL "1")
	set(DETECTED_ROS1 TRUE)
	set(PACKAGE_ROS_VERSION 1)
	set (CMAKE_CXX_STANDARD 14)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(default_build_type "Release")
	message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
	set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
endif()
# Set the possible values of build type for cmake-gui
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "SanitizeAddress" "SanitizeThread")

# CMake file for the library target
project(mvsim)

#----
# Extract version from package.xml
# Example line:" <version>0.3.2</version>"
file(READ package.xml contentPackageXML)
string(REGEX MATCH "<version>([0-9\.]*)</version>" _ ${contentPackageXML})
set(MVSIM_VERSION ${CMAKE_MATCH_1})
message(STATUS "MVSIM version: ${MVSIM_VERSION} (detected in package.xml)")
string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" _ ${MVSIM_VERSION})
set(MVSIM_MAJOR_VERSION ${CMAKE_MATCH_1})
set(MVSIM_MINOR_VERSION ${CMAKE_MATCH_2})
set(MVSIM_PATCH_VERSION ${CMAKE_MATCH_3})
#TODO: Avoid overwritting source dir.
configure_file(
	cmake/mvsim_version.h.in
	${CMAKE_CURRENT_SOURCE_DIR}/modules/simulator/include/mvsim/mvsim_version.h
	@ONLY
	)
#----

# This is required for pybind11 to generate C++17 code in all OS versions:
set(CMAKE_CXX_STANDARD 17 CACHE STRING "C++ version selection")
set(CMAKE_CXX_STANDARD_REQUIRED ON)  # optional, ensure standard is supported
set(CMAKE_CXX_EXTENSIONS OFF)  # optional, keep compiler extensions off


find_package(Threads)
include(GNUInstallDirs)
include(cmake/mvsim_cmake_functions.cmake REQUIRED)

if (POLICY CMP0057)
	cmake_policy(SET CMP0057 NEW) # IN_LIST (needed by pybind11 cmake scripts)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	# BUILD_TYPE: SanitizeAddress
	set(CMAKE_CXX_FLAGS_SANITIZEADDRESS "-fsanitize=address  -fsanitize=leak -g")
	set(CMAKE_EXE_LINKER_FLAGS_SANITIZEADDRESS "-fsanitize=address  -fsanitize=leak")
	set(CMAKE_SHARED_LINKER_FLAGS_SANITIZEADDRESS "-fsanitize=address  -fsanitize=leak")
	
	# BUILD_TYPE: SanitizeThread
	set(CMAKE_CXX_FLAGS_SANITIZETHREAD "-fsanitize=thread -g")
	set(CMAKE_EXE_LINKER_FLAGS_SANITIZETHREAD "-fsanitize=thread")
	set(CMAKE_SHARED_LINKER_FLAGS_SANITIZETHREAD "-fsanitize=thread")
endif()


# ------------------------------------------------------------------
#                              IMPORTANT NOTE
#
#  This package can be built as:
#  1) Standalone lib+app
#  2) ROS1 or ROS2 node(s)
# Depending on what packages are found, this script will instruct
# CMake to configure the project accordingly.
# ------------------------------------------------------------------

# ROS1:
set(BUILD_FOR_ROS FALSE)
if (DETECTED_ROS1)
	set(BUILD_FOR_ROS TRUE)
endif()

# ROS2:
if (DETECTED_ROS2)
	set(BUILD_FOR_ROS TRUE)

	find_package(rclcpp REQUIRED)
endif()


if (BUILD_FOR_ROS)
	message(STATUS " ==== multivehicle-simulator: ROS$ENV{ROS_VERSION} detected. ROS nodes will be built. ===== ")
	add_definitions(-DMVSIM_HAS_ROS)
endif()


# -----------------------------------------------------------------------------
#  ROS1
# -----------------------------------------------------------------------------
if (BUILD_FOR_ROS AND DETECTED_ROS1)
	# Find catkin macros and libraries
	# if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
	# is used, also find other catkin packages
	find_package(catkin
		REQUIRED
		COMPONENTS
		roscpp tf2 dynamic_reconfigure std_msgs nav_msgs sensor_msgs visualization_msgs
		tf2_geometry_msgs
	)
	find_package(mrpt-ros1bridge 2.5.6 REQUIRED)

	#add dynamic reconfigure api
	if (dynamic_reconfigure_FOUND)
		generate_dynamic_reconfigure_options(
			cfg/mvsimNode.cfg
			)
	endif()

	###################################
	## catkin specific configuration ##
	###################################
	## The catkin_package macro generates cmake config files for your package
	## Declare things to be passed to dependent projects
	## INCLUDE_DIRS: uncomment this if you package contains header files
	## LIBRARIES: libraries you create in this project that dependent projects also need
	## CATKIN_DEPENDS: catkin_packages dependent projects also need
	## DEPENDS: system dependencies of this project that dependent projects also need

	catkin_package(
	  CATKIN_DEPENDS
			dynamic_reconfigure nav_msgs roscpp sensor_msgs visualization_msgs
			tf2 tf2_geometry_msgs
	#  INCLUDE_DIRS include
	#  LIBRARIES mrpt_localization
	#  DEPENDS mrpt
	)
endif()

# -----------------------------------------------------------------------------
#  ROS2
# -----------------------------------------------------------------------------
if (BUILD_FOR_ROS AND DETECTED_ROS2)
	# find dependencies
	find_package(ament_cmake REQUIRED)
	find_package(geometry_msgs REQUIRED)
	find_package(tf2 REQUIRED)
	find_package(nav_msgs REQUIRED)
	find_package(sensor_msgs REQUIRED)
	find_package(visualization_msgs REQUIRED)
	find_package(tf2_geometry_msgs REQUIRED)

	find_package(mrpt-ros2bridge 2.5.6 REQUIRED)
endif()


# --------------------------
# Build options
# --------------------------
if (UNIX)
	set(DEFAULT_SHARED_LIBS ON)
else()
	set(DEFAULT_SHARED_LIBS OFF)
endif()
set(BUILD_SHARED_LIBS ${DEFAULT_SHARED_LIBS} CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")

# Save all libs and executables in the same place
if (NOT BUILD_FOR_ROS)
	set( LIBRARY_OUTPUT_PATH ${${PROJECT_NAME}_BINARY_DIR}/lib CACHE PATH "Output directory for libraries" )
	set( EXECUTABLE_OUTPUT_PATH ${${PROJECT_NAME}_BINARY_DIR}/bin CACHE PATH "Output directory for applications" )
endif()

set(CMAKE_DEBUG_POSTFIX "-dbg")

# --------------------------
# Global compiler flags
# --------------------------
if(MSVC)
	# Force usage of UNICODE projects, which is not the default in MSVC:
	add_definitions(-DUNICODE -D_UNICODE)
endif()

# ----------------------------------------------------------
# Dependency: MRPT
# Use the first cmd to set the minimum required version
# ----------------------------------------------------------
find_package(mrpt-maps 2.5.6 REQUIRED)
find_package(mrpt-tclap 2.5.6 REQUIRED)
find_package(mrpt-gui 2.5.6 REQUIRED)
find_package(mrpt-tfest 2.5.6 REQUIRED)

# --------------------------
# Dependency: Box2D
# --------------------------
set(EMBEDDED_box2d_BUILD_DIR "${${PROJECT_NAME}_BINARY_DIR}/externals/box2d/")
set(EMBEDDED_box2d_INSTALL_DIR "${${PROJECT_NAME}_BINARY_DIR}/externals/box2d/install/")
set(EMBEDDED_box2d_DIR "${EMBEDDED_box2d_INSTALL_DIR}/lib/cmake/box2d/")

# 1st) Try to locate it via CMake (installed in the system or precompiled somewhere)
# Since box2d 2.4.1, the name changed "Box2D" -> "box2d". We now only support the version >=2.4.x
# for compatibility with modern Ubuntu distros:
#
# Update: Since MVSIM 0.7.0, we now always ship a custom build of box2d to 
# increase its default maximum number of polygon vertices:
##find_package(box2d QUIET) # Defines: box2d::box2d

if (NOT box2d_FOUND)
	message(STATUS "--- Running CMake on external submodule 'box2d'...")
	file(MAKE_DIRECTORY "${EMBEDDED_box2d_BUILD_DIR}")
	if(NOT ${CMAKE_VERSION} VERSION_LESS "3.15")
		set(echo_flag COMMAND_ECHO STDOUT)
	endif()
	execute_process(COMMAND
		${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" "${${PROJECT_NAME}_SOURCE_DIR}/externals/box2d"
		-DBOX2D_BUILD_DOCS=OFF
		-DBOX2D_BUILD_TESTBED=OFF
		-DBOX2D_BUILD_UNIT_TESTS=OFF
		-DCMAKE_POSITION_INDEPENDENT_CODE=ON
		-DCMAKE_INSTALL_PREFIX=${EMBEDDED_box2d_INSTALL_DIR}
	RESULT_VARIABLE result
	WORKING_DIRECTORY "${EMBEDDED_box2d_BUILD_DIR}"
	${echo_flag}
	)
	if(result)
		message(FATAL_ERROR "CMake step for box2d failed: ${result}")
	endif()

	execute_process(COMMAND
		${CMAKE_COMMAND} --build ${EMBEDDED_box2d_BUILD_DIR} --target install
	RESULT_VARIABLE result
	${echo_flag}
	)
	if(result)
		message(FATAL_ERROR "CMake make install step for box2d failed: ${result}")
	endif()
	message(STATUS "--- End running CMake")

	# Search again:
	set(box2d_DIR "${EMBEDDED_box2d_DIR}" CACHE PATH "Path to box2d CMake config file" FORCE)
	mark_as_advanced(box2d_DIR)
	find_package(box2d CONFIG QUIET)

    # install the embedded copy too (we need box2d-config.cmake, etc.)
	execute_process(COMMAND
		${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" "${${PROJECT_NAME}_SOURCE_DIR}/externals/box2d"
		-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
	RESULT_VARIABLE result
	WORKING_DIRECTORY "${EMBEDDED_box2d_BUILD_DIR}"
	${echo_flag}
	)
    install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} --build \"${EMBEDDED_box2d_BUILD_DIR}\" --target install)")
endif()

if (NOT box2d_FOUND)
    message(FATAL_ERROR "box2d not found, neither as system library nor git submodule. Check error messages above for possible reasons.")
endif()

if (box2d_FOUND)
	set(BOX2D_LIBRARIES box2d::box2d)
endif()

# --------------------------
#  Main library modules
# --------------------------
add_subdirectory(modules)

# --------------------------
#       Apps
# --------------------------
add_subdirectory(mvsim-cli)

if (BUILD_FOR_ROS)
	###########
	## Build ##
	###########

	## Declare a cpp executable
	add_executable(mvsim_node
		mvsim_node_src/mvsim_node.cpp
		mvsim_node_src/mvsim_node_main.cpp
		mvsim_node_src/include/mvsim/mvsim_node_core.h
	)
	
	mvsim_set_target_build_options(mvsim_node)

	target_include_directories(mvsim_node PRIVATE "mvsim_node_src/include")

	if (catkin_INCLUDE_DIRS)
		# Specify additional locations of header files
		# Your package locations should be listed before other locations
		target_include_directories(mvsim_node PUBLIC ${catkin_INCLUDE_DIRS})
	endif()

	if (DETECTED_ROS1)
		add_dependencies(mvsim_node
			mvsim_gencfg
		)

		target_link_libraries(mvsim_node 
			#PRIVATE  # ros catkin already used the plain signature, we cannot use this here...
			${catkin_LIBRARIES}
			mrpt::ros1bridge
		)

		# make sure configure headers are built before any node using them
		if (${PROJECT_NAME}_EXPORTED_TARGETS})
			add_dependencies(mvsim_node ${${PROJECT_NAME}_EXPORTED_TARGETS})
		endif()
	elseif(DETECTED_ROS2)
		ament_target_dependencies(mvsim_node
			rclcpp
			geometry_msgs
			nav_msgs
			sensor_msgs
			visualization_msgs
			tf2
			tf2_geometry_msgs
		)

		target_link_libraries(mvsim_node
			#PRIVATE  # ros ament already used the plain signature, we cannot use this here...
			mrpt::ros2bridge
		)

		# We need this to handle this backwards-incompatible change: https://github.com/ros2/geometry2/pull/416
		if("${tf2_geometry_msgs_VERSION}" VERSION_GREATER_EQUAL "0.18.0")
			target_compile_definitions(mvsim_node PRIVATE MVSIM_HAS_TF2_GEOMETRY_MSGS_HPP)
		endif()

	endif()

	target_compile_definitions(mvsim_node PRIVATE
	PACKAGE_ROS_VERSION=${PACKAGE_ROS_VERSION}
	)

	# Specify libraries to link a library or executable target against
	target_link_libraries(
		mvsim_node
		#PRIVATE  # ros ament already used the plain signature, we cannot use this here...
		mvsim::simulator
		mvsim::msgs
		mvsim::comms
		${BOX2D_LIBRARIES}  # Box2D libs
		${catkin_LIBRARIES}
		${CMAKE_THREAD_LIBS_INIT}
	)

	if (DETECTED_ROS1)

=== mvsim-cli/CMakeLists.txt ===
project(mvsim)

# === Define executable ===
add_executable(${PROJECT_NAME} 
	mvsim-cli-main.cpp
	mvsim-cli-node.cpp
	mvsim-cli-topic.cpp
	mvsim-cli-launch.cpp
	mvsim-cli-server.cpp
	mvsim-cli.h
)
target_link_libraries(
	${PROJECT_NAME}
	mvsim::simulator
	mvsim::msgs
	mvsim::comms
	mrpt::tclap
	${BOX2D_LIBRARIES}  # Box2D libs
	${CMAKE_THREAD_LIBS_INIT}
	)

mvsim_set_target_build_options(${PROJECT_NAME})

install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== debian/changelog ===
ros-foxy-mvsim (0.7.0-1focal) focal; urgency=high

  * Automatic detection of collision shapes
  * Add turtlebot world demo
  * Rely on custom build of Box2D to increase the maximum polygon vertices count (8 to 12).
  * fix inconsistent use_sim_time value for ROS 2 (it should be false)
  * Expose shadow rendering parameters in the XML world file
  * Abort simulation on exceptions in headless mode too
  * ROS 1 and 2 nodes now quit cleanly and quickly with SIGINT
  * Add ros2 launch for turtlebot world demo
  * Automatic determination of zmin/zmax for blocks if not explicitly set in XML
  * Force c++17 for python module
  * Exit simulator on exceptions in GUI-related threads
  * More automated testing
  * Add unit tests in C++ too
  * Refactor collision shape determination
  * New UI checkbox: show collision shapes
  * Allow simply geometry definitions without external 3D model file for "blocks"
  * Light options are now under <light> XML tag.
  * Largest default physics simulation timestep changed from 50ms to 5ms
  * GUI: change light direction
  * Add GUI checkbox to enable/disable shadows
  * Add rplidar A2 sensor model
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 20 Apr 2023 22:00:00 -0000

ros-foxy-mvsim (0.6.1-1focal) focal; urgency=high

  * New XML parameters to enable and tune shadowmap generation
  * Use finer timestep for prevent wrong simulation of ramp sliding
  * Fix code notation
  * Temporary workaround to GH CI problem
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Fri, 03 Mar 2023 23:00:00 -0000

ros-foxy-mvsim (0.6.0-1focal) focal; urgency=high

  * Support for SkyBox rendering (requires MRPT >=2.7.0)
  * More camera options in world.xml files (initial azimuth, elevation, etc.)
  * Terrain elevation models now support repeated textures (requires MRPT >=2.7.0)
  * Faster 3D Lidar rendering (Requires MRPT >=2.7.0)
  * Add Ouster OS1 sensor file
  * Fix default friction coefficients; draw motor torques too
  * More accurate Velodyne simulation based on sensor_rpm parameter
  * Clearer code and code style conventions
  * Add "<static>" XML tag for large, static world objects
  * Support for XML tag <if ...>
  * Refactor xml parser as a registry of tag->function
  * Examples renamed for conciseness: 'mvsim_demo_*' to 'demo_*'
  * Added a "greenhouse" example world
  * Wheels: allow linked-yaw-objects in vehicle viz
  * Support several <visual> tags in custom visualization models
  * pybind11 sources simplification.
    Simplify into one single source tree with conditional compilation for different pybind versions.
  * Emit clearer warnings and earlier detection of wrong bounding boxes
  * Add reference to (preprint) paper
  * Controllers: Made threadsafe
  * Contributors: Fernando Cañadas, Jose Luis Blanco-Claraco
  * BUGFIX: program did not quit if using a non-existing launch file.
  * BUGFIX: unneeded friction coefficient for chassis body
  * BUGFIX: bbox for compound vehicle models
  * BUGFIX: <for> loops ignored more than one inner tag
  * BUGFIX: Add epsilon value for bbox determination in 3D models

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sat, 25 Feb 2023 23:00:00 -0000

ros-foxy-mvsim (0.5.2-1focal) focal; urgency=high

  * FIX build farm errors in armhf builds
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Thu, 26 Jan 2023 23:00:00 -0000

ros-foxy-mvsim (0.5.1-1focal) focal; urgency=high

  * FIX: Stuck unit test runs in armhf build farms
  * Add demo with a large number of robots (100) in a simple setup
  * Support <for> loops in world definition files
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Wed, 25 Jan 2023 23:00:00 -0000

ros-foxy-mvsim (0.5.0-1focal) focal; urgency=high

  * New warehouse demo world file, including ros2 launch.
  * New feature: download models from remote servers.
  * Add 3D Lidar sensor.
  * Add support for headless simulations (mvsim launch --headless), suitable for running inside docker containers
  * New world element: vertical planes.
  * Add <for /> loops in XML world files
  * Support for formulas in XML files via  exprtk expressions
  * Fix naming convention; fix warnings
  * Move to clang-format-11
  * More consistent class member naming convention
  * Add simple Velodyne sensor DAE model
  * Add wget as build and runtime dep
  * PubSub system: Implemented the feature to notify subscribed clients about a new publisher for a topic
  * New 3D model: pioneer3
  * ROS: Add build and test dep python3-protobuf
  * Added unit tests
  * mvsim cli: add the --realtime-factor flag
  * more topic echo types
  * publish 2D lidar observations as custom protobuf msgs too
  * Add new protobuf msg type ObservationLidar2D.proto
  * add shutdown service
  * Fixed Python topic subscription and parsing
  * avoid potential crash during shutdown
  * FIX: Timelogger verbosity level is now copied from the main World object.
  * BUGFIX: Lidar sensors with ignore_parent_body=true should neither see the wheels
  * Tune PID parameters of examples
  * Refactoring and simplification of mutexes
  * cache GetServiceInfoRequest() calls (more efficient service calls in comms::Client)
  * factorize World services into its own .cpp file for clarity
  * Contributors: Jose Luis Blanco-Claraco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sun, 08 Jan 2023 23:00:00 -0000

ros-foxy-mvsim (0.4.3-1focal) focal; urgency=high

  * add names to gl objects (useful to debug)
  * configurable gui open timeout
  * GUI: new button Editor->Export 3Dscene file
  * Add a warning if using a physics timestep is incompatible with the sensor periods
  * FIX: more accurate simulation of timesteps; more mutexes
  * automatic determination of timestep; FIX bug: constant offset in simul time
  * fix FBO api for mrpt 2.5.6


=== debian/control ===
Source: ros-foxy-mvsim
Section: misc
Priority: optional
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gmock, ros-foxy-ament-cmake-gtest, ros-foxy-ament-cmake-xmllint, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-mrpt2, ros-foxy-nav-msgs, ros-foxy-ros-environment, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-tf2-geometry-msgs, ros-foxy-visualization-msgs, unzip, wget, ros-foxy-ros-workspace
Homepage: https://wiki.ros.org/mvsim
Standards-Version: 3.9.2

Package: ros-foxy-mvsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-foxy-mrpt2, ros-foxy-nav-msgs, ros-foxy-ros2launch, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-tf2-geometry-msgs, ros-foxy-visualization-msgs, unzip, wget, ros-foxy-ros-workspace
Description: A lightweight multivehicle simulation framework.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-mvsim//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
